bootstrap-script.sh 1.7 KB

123456789101112131415161718192021222324252627282930313233343536373839404142
  1. #!/bin/bash
  2. #
  3. # This script is a startup script for bootstrapping a GCP node
  4. # from a config stored in the project metadata. It loops until
  5. # it finds the script and then starts the origin-node service.
  6. # TODO: generalize
  7. set -o errexit
  8. set -o nounset
  9. set -o pipefail
  10. if [[ "$( curl "http://metadata.google.internal/computeMetadata/v1/instance/attributes/bootstrap" -H "Metadata-Flavor: Google" )" != "true" ]]; then
  11. echo "info: Bootstrap is not enabled for this instance, skipping" 1>&2
  12. exit 0
  13. fi
  14. if ! id=$( curl "http://metadata.google.internal/computeMetadata/v1/instance/attributes/cluster-id" -H "Metadata-Flavor: Google" ); then
  15. echo "error: Unable to get cluster-id for instance from cluster metadata" 1>&2
  16. exit 1
  17. fi
  18. if ! node_group=$( curl "http://metadata.google.internal/computeMetadata/v1/instance/attributes/node-group" -H "Metadata-Flavor: Google" ); then
  19. echo "error: Unable to get node-group for instance from cluster metadata" 1>&2
  20. exit 1
  21. fi
  22. if ! config=$( curl -f "http://metadata.google.internal/computeMetadata/v1/instance/attributes/bootstrap-config" -H "Metadata-Flavor: Google" 2>/dev/null ); then
  23. while true; do
  24. if config=$( curl -f "http://metadata.google.internal/computeMetadata/v1/project/attributes/${id}-bootstrap-config" -H "Metadata-Flavor: Google" 2>/dev/null ); then
  25. break
  26. fi
  27. echo "info: waiting for ${id}-bootstrap-config to become available in cluster metadata ..." 1>&2
  28. sleep 5
  29. done
  30. fi
  31. echo "Got bootstrap config from metadata"
  32. mkdir -p /etc/origin/node
  33. echo -n "${config}" > /etc/origin/node/bootstrap.kubeconfig
  34. echo "BOOTSTRAP_CONFIG_NAME=node-config-${node_group}" >> /etc/sysconfig/origin-node
  35. systemctl enable origin-node
  36. systemctl start origin-node